<!DOCTYPE html>
<html lang="en" dir="ltr">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="">
    <title>Learning and tutorials</title>
    <link rel="stylesheet" href="/Resources/Files/styles.css">
  </head>
  <body>
    <header>
    </header>
    <navigation>
      <div>
        <ul>
          <li><a href="/Content/Writing/writing.html">Writing</a></li>
          <li><a href="/Content/Photography/photography.html">Photography</a></li>
          <li><a href="/Content/Book_Log/book_log.html">Book Log</a></li>
          <li><a href="/Content/Startups/startups.html">Startups</a></li>
          <li><a href="/Content/Learning/learning.html">Learning</a></li>
          <li><a href="/Content/Projects/side_projects.html">Side Projects</a></li>
        </ul>
      </div>
    </navigation>
    <div class="main-content">
      <div class="container" style="background-color: #efefef">
      <h1>CSS TUTORIAL</h1>
      (Source: https://www.youtube.com/watch?v=c9B4TPnak1A&t=1268s)

      <ul class="list-group" style="width:20%;">
        <li class="list-group-item"><a href="#css_selections">CSS selections</a></li>
        <li class="list-group-item"><a href="#css_combinator_selector">CSS selections combinator</a></li>
        <li class="list-group-item"><a href="#css_display">CSS display</a></li>
        <li class="list-group-item"><a href="#css_attributes">CSS Attributes</a></li>
      </ul>


      <h2>Generic CSS and Atom notes</h2>
        <ul>
          <li>when we create a class , we can "shorten" its name by adding an "*" to the class name. by doing that we will enable a regular expression maching fro all the objects that matches that class name</li>
          <li>So, a class defined like: class*="con" will match an entity like this: &ltp class="container" &gt </li>
          <li>A quick way to add a new class is to enter a '.' and then the class name. So, '.container' will ad a new div with class container instance</li>
        </ul>
        <hr>


      <h2>CSS</h2>
      <h3 id="css_selections">CSS selections</h3>
        <p>This is the <a href="https://www.youtube.com/watch?v=PP3j1YJbbRY&list=LL&index=4&t=370s">source</a> I checked</p>
          <table class="table">
              <thead class="thead-dark">
                <tr>
                <th scope="col">ITEMS SELECTED</th>
                <th scope="col">SYNTAX</th>
              </tr>
              </thead>
              <tbody>
                <tr>
                  <th scope="row">Selecting by TYPE</th>
                  <td>Use an element' HTML tag (p, table, a, etc) type to select all the elements matching that value</td>
                </tr>
                <tr>
                  <th scope="row">Selecting by ID</th>
                  <td>Use # to select an element using it's ID value</td>
                </tr>
                <tr>
                  <th scope="row">Selecting by CLASS</th>
                  <td>Use . to select an element using it's CLASS value</td>
                </tr>
                <tr>
                  <th scope="row">Selecting all (default values)</th>
                  <td>Use * to select all the elements of the document,. this can be used as a default valur or "reset"</td>
                </tr>
              </tbody>
            </table>
      <hr>

      <h3 id="css_combinator_selector">CSS Selection Combinators</h3>
        <p>This is the <a href="https://www.youtube.com/watch?v=1170wEltVYg">source</a> I checked</p>
        <p>In order to select multiple elements on screen, we can simply separate them by commas. So:</p>
        <p style="display:inline;"><code>p, table, button {.... }</code></p>
        <p> will select all of the paragraphs, tables and buttons on the screen, regardless of their hyerarchical relationship.</p>
        <p>If what we want to do is select elements that are nested within each other (even if they are not in adjacent levels), we will separate them using whitespaces. So, similarly to the previous example: </p>
        <p style="display:inline;"> <code>#elementID table button {.... }</code></p>
        <p>would select the button that is inside the table of the element with the id "elementID" (whatever element that might be)</p>
        <p>If what we want to do is select elements that are directly under an elements level we will separate them using ">" symbol. So, similarly to the previous example: </p>
        <p style="display:inline;"> <code>#elementID > table button {.... }</code></p>
        <p>Finally, if what we want to do id select all the elements that come (in the document, not hyerarchically) right after a given one, we can use the "+" symbol</p>
        <p>If what we want to do is select elements that are directly under an elements level we will separate them using ">" symbol. So, similarly to the previous example: </p>
        <p style="display:inline;"> <code>#elementID + table{.... }</code></p>
        <p>Will select the table that is coded right after the element with element ID "elementID"</p>
        <script type="text">
        <p id="elementID">
          /* this table will be selected although there is no hyerarchical relationship between them*/
          <table>
            .......
          </table>
        </p></script>
      <hr>

      <h3 id="css_display">CSS Display</h3>
        <p>we can use these types of visualizations for CSS elements</p>
          <ul>
            <li><b>Inline</b>: an inline element will only take the space take by its content, regardless how large the screen is. Consequently, inline element will line up in the same line when possible. Elements that are inline by default are: a, img, buttons, etc. See the full list <a href="https://www.w3schools.com/html/html_blocks.asp"> here</a></li>
            <li><b>Block</b>: a block element takes wthe full width of the screen, even when it is resized. Elements that are block by default are: divs, tables, footer, forms, headers, etc. See the full list <a href="https://www.w3schools.com/html/html_blocks.asp"> here</a></li>
          </ul>
          <p>If we want to remove an item from screen, and also free the space that it occupies, we wili use the property <code>display</code> and set it to none. If we want to remove an item, but keeping the real state,  we will simply set the  <code>visibility</code> property to hidden.</p>
      <hr>

      <h3 id="css_attributes">CSS Attributes</h3>
        <p>(<a href="https://www.youtube.com/watch?v=Md4H-7jsTfI&t=380s">source</a>) Let's start with these three simple fields of a form:</p>
        <div style="padding-left:3rem;">
          <input type="text" placeholder="TEXT">
          <input type="email" placeholder="EMAIL">
          <input type="button" value="Click Me">
        </div>
        <p>we can select all the elements based on an attibute <u>name</u> (and not the value) </p>
          <ul>
            <code>input [type]
            {
              border:2px solid orangered;
            }
          </code>
          </ul>
          <p>will apply to the borders of all three input elements, because  all of them have an attributte called "type" (regardless of its value)</p>
          <p>In order to apply the changes to a specific type of input, we can specify the type of input that we want to apply the changes:</p>
          <ul>
            <code>input [type="text"]
            {
              background-color:blue;
            }
          </code>
          </ul>
          <p>The change above will only be applied to the <u>text</u> type of input</p>
          <p>We can also apply some simple regular expressions. So, if we want to select some styling to some elements that have a field called "title" whose value starts with "t-", we can do it with the following code:</p>
          <ul>
            <code>input [type^="t-"]
            {
              background-color:grey;
            }
          </code>
          </ul>
      <hr>
    </div>
    <footer>
      <a href="mailto:jose.gorchs@gmail.com"><img src="/Resources/Images/mail-icon.png" alt=""></a>
      <a href="https://www.linkedin.com/in/josegorchs/"><img src="/Resources/Images/linkedin-icon.png" alt=""></a>
      <a href="https://github.com/Gorchs?tab=repositories"><img src="/Resources/Images/git-icon.png" alt=""></a>
    </footer
  </body>
</html>
